
(* DIS6502 v2.2 (03.08.2008 - 01.11.2009) by Tebe/Madteam                                  *)

// Free Pascal Compiler, http://www.freepascal.org/
// Compile: fpc -Mdelphi -vh -O3 dis6502.pas


program dis6502;

{$APPTYPE CONSOLE}

//uses
//  SysUtils;

var f, g, ou, t: textfile;
    h: file of byte;
    i, k, Code, Licz, skp, cpu, _adr, org, dlug, lin: integer;
    a, b, out, plik, adr, adr2, _old, name, tmp, txt: string;
    bajt,byt,hlp,pom,pass,store,_byt,zamiana,data,mnemo: byte;

    len: byte;       // !!! koniecznie BYTE !!!

    store_type: char = 'D';

    ram, ram2, use:array [0..8191] of byte;

    status, ok, typ, loop: Boolean;

    par:array [0..4] of byte;
    tab:array [0..255] of string;
    wor:array [0..127] of string;

    tst: array [0..$FFFF] of record
                              typ: Boolean;   // TRUE = CODE, FALSE = DATA
                              beg: Boolean;   // TRUE = BLOCK BEGIN
                              siz: char;      // B - BYTE, W - WORD
                             end;
    label stop0;

const
     tand:array [0..7] of byte=($80,$40,$20,$10,8,4,2,1);
     Ety='E_';
     Spa=#9;

     
function IntToStr(const a: integer): string;
var tmp: string;
begin
 str(a, tmp);

 Result := tmp;
end;


function StrToInt(var a: string): Int64;
var i: integer;
begin
 val(a,Result, i);
end;


function ata2int(const a: byte): byte;
(*----------------------------------------------------------------------------*)
(*  zamiana znakow ATASCII na INTERNAL                                        *)
(*----------------------------------------------------------------------------*)
begin
 Result:=a;

 case Result of
    0..31: inc(Result,64);
   32..95: dec(Result,32);
 end;

end;
           

function IntToHex(a:cardinal; b:shortint): string;
(*----------------------------------------------------------------------------*)
(*  zamiana na zapis hexadecymalny                                            *)
(*  'B' okresla maksymalna liczbe nibbli do zamiany                           *)
(*  jesli sa jeszcze jakies wartosci to kontynuuje zamiane                    *)
(*----------------------------------------------------------------------------*)
var v: byte;

const
    tHex: array [0..15] of char =
    ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

begin
 Result:='';

 while (b>0) or (a<>0) do begin

  v := byte(a);
  Result:=tHex[v shr 4] + tHex[v and $0f] + Result;

  a:=a shr 8;

  dec(b,2);
 end;

end;


function znaki(a: byte): Boolean;
begin
 Result:= chr(a) in [' ','A'..'Z','a'..'z','0'..'9','!','@','#','$','%','^','&','*','(',')','-','=','[',']',':',';','''','"',',','.','<','>','?','/'];
end;


function na_znaki(a: byte): char;
begin

 Result:='D';

 if (store_type='A') and (znaki(a)) then Result:='A';

//  else
//  if (store_type='I') and (znaki(ata2int(a))) then Result:='I';

end;


function AccessFile(a: string): Boolean;
(*----------------------------------------------------------------------------*)
(*  sprawdzamy mozliwosc zapisu do pliku o podanej nazwie                     *)
(*----------------------------------------------------------------------------*)
var pl: textfile;             // !!! koniecznie plik tekstowy !!!
begin

 Result:=true;

 AssignFile(pl,a);
 {$I-}
 FileMode:=1;
 Rewrite(pl);
 CloseFile(pl);
 {$I+}

 if (IOResult <> 0) or (a='') then Result:=false;
end;


function TestFile(a: string): Boolean;
{*----------------------------------------------------------------------------*}
{*  sprawdzamy istnienie pliku na dysku bez udzialu 'SysUtils',               *}
{*  jest to odpowiednik funkcji 'FileExists'                                  *}
{*----------------------------------------------------------------------------*}
var pl: textfile;
begin
 TestFile:=true;

 AssignFile(pl, a);
 {$I-}
 FileMode:=0;
 Reset(pl);
 CloseFile(pl);
 {$I+ }

 if IOResult<>0 then TestFile:=false;
end;


function TestRam(ad:integer): byte;
begin
 Result:=0;
 
 if use[ad div 8] and tand[ad mod 8]>0 then
  Result:=ram[ad div 8] and tand[ad mod 8];
end;


function Etykieta:string;
begin
 Etykieta:=Spa;

 if pass=2 then begin
  if TestRam(cpu)>0 then Etykieta:=Ety+IntToHex(cpu,4)+Spa;
 end;

end;


procedure SaveAsm(o:string);
begin
 if pass=2 then writeln(ou, o);
end;


function TestEty(x,x_:string):string;
var   i:integer;
begin
 i:=pos(copy(tab[_byt],1,3),x);
 insert(x_+Spa,x,i);

 TestEty:=x;
end;


procedure SaveAsmTst(o: string);
var b: string;
begin

if (o=_old) and (pos('dta',o)<1) then
 inc(licz)
else
 if licz>0 then begin

  b:=TestEty(_old,':'+IntToStr(licz+1)); licz:=0;
                          
  if pos('?',b)=0 then begin
   writeln(ou,b);
   inc(lin);
  end;

 end else
  if pos('?',_old)=0 then begin
   writeln(ou,_old);
   inc(lin);
  end;

_old:=o; _byt:=byt;
end;


procedure SaveOrg(ad: integer);
begin
SaveAsm(';--------------------------');
SaveAsm(#9+'org $'+IntToHex(ad,4));
SaveAsm(';--------------------------');
end;


procedure Mnemonik(px, ln: integer);
var p, q, i: integer;
    c, d: string;
begin

if px>0 then begin
 len:=ln; q:=0;
 for p:=0 to ln-2 do if (cpu-org+p+1)<Dlug then begin read(h,par[p]); inc(q); end;
 ln:=q+1;
 adr:=IntToHex(par[0],2); if ln=3 then adr:=IntToHex(par[1],2)+adr;

 { skok warunkowy L +- }
 if a[px]='L' then begin
  if par[0]>=128 then _adr:=(cpu-($100-par[0])+len) else _adr:=(cpu+par[0]+len);
  adr:=IntToHex(_adr,4);
 end;

 while length(adr)<4 do adr:='0'+adr;

 adr:='$'+adr; val(adr,_adr,Code);

 { *- jesli adres Q (word) nie przekroczyl wartosc Z (byte) -* }
if (pos('jmp',a)=0) and (pos('jsr',a)=0) then begin

 if a[px]='Q' then
  if _adr<$100 then begin
   px:=pos('Q',a)+2;
   insert('.w',a,4);
  end;

end;


 if cpu-org+len>Dlug then begin
  px:=Dlug-cpu-1;
  a:='dta $'+IntToHex(byt,2);
  if px>0 then for p:=0 to px-1 do a:=a+',($'+IntToHex(par[p],2)+')';
  adr:=' '; a:=a+' '; px:=length(a);
 end;


 if pass=1 then begin

  p:=_adr div 8;
  if (_adr<$d000) or (_adr>=$d800) then ram[p]:=(ram[p] or tand[_adr mod 8]);

 end else begin

  bajt:=TestRam(_adr);

  if (bajt>0) and (_adr>=org) and (_adr<=org+dlug-2) then
   if a[px]<>'N' then adr:=Ety+copy(adr,2,4);

  if a[px]='N' then                            // jest wartosc absolutna <$100 to usun zera 00
   if StrToInt(adr)<$100 then delete(adr,2,2);

  { *- sprawdzamy czy w srodku rozkazu jest odwolanie -* }
  for p:=len-1 downto 1 do
   if TestRam(cpu+p)>0 then begin
    adr2:=Ety+IntToHex(cpu,4);
    c:=Ety+IntToHex(cpu+p,4)+adr2+'+'+chr($30+p);
    writeln(t,copy(c,1,32));
   end;

 end;


if (pass=2) and (Zamiana=1) and (pos('#',a)=0) then begin
 val(adr,_adr,Code);

 bajt:=ram2[_adr div 8] and tand[_adr mod 8];

 if bajt>0 then begin
  d:=adr; if length(d)=3 then d:='$00'+copy(d,2,2);

  assignFile(g,'_temp.$$$'); reset(g); 

  while true do begin
   readln(g,c);
   for i:=1 to length(c) do c[i]:=UpCase(c[i]);

   if pos(d,c)>0 then Break;
  end;

  closeFile(g);

  adr:=copy(c,1,pos(' ',c)-1);
 end;

end;


 if Mnemo>0 then begin           // zapisuj dane DTA zamiast mnemonikow

  case a[px] of
   'L','Z','N': a:='dta $'+IntToHex(byt,2)+',$'+IntToHex(par[0],2);
   'Q': a:='dta $'+IntToHex(byt,2)+',a($'+IntToHex(par[1],2)+IntToHex(par[0],2)+')';
  end;

 end else begin
  delete(a,px,1);
  insert(adr,a,px);
 end;


while a[length(a)]=' ' do delete(a,length(a),1);

end;

end;


function Decode(ofs:byte):string;
begin
 len:=1; a:=tab[ofs];         { mnemonik }
 Mnemonik(pos('N',a),2);      { a tutaj parametr dla mnemonika }
 Mnemonik(pos('Q',a),3);
 Mnemonik(pos('Z',a),2);
 Mnemonik(pos('L',a),2);

 if (store>0) and (pass=2) then begin

   case store_type of
        'D': SaveAsm('');
    'A','I': SaveAsm(#39);
   end;

   store:=0;
 end;

 Decode:=a;
end;

function getString(p:char): string;
var b:string;
    i:byte;
begin
 b:=a;
 while pos(#9,b)>0 do begin i:=pos(#9,b); delete(b,i,1); insert(' ',b,i); end;
 getString:=copy(b,1,pos(p,b)-1);
 a:=copy(b,pos(p,b)+1,length(b));
end;

procedure Info;
begin
 writeln('Syntax: DIS6502 source [options]');
 writeln('-d'#9#9'save as data block, example: dta $..,$..');
 writeln('-l'#9#9'label name, example: $d301 -> portb (default OFF)');
 writeln('-m'#9#9'mnemonic OFF (default ON)');
 writeln('-a$xxxx'#9#9'address of disasembled memory block (default $0400)');
 writeln('-s$xxxx'#9#9'skip $xxxx bytes of begining memory block (default 0)');
 writeln('-sd'#9#9'store data block dta b($..,$..)');
 writeln('-sa'#9#9'store atascii character block dta c'#39' '#39);
// writeln('-si'#9#9'store internal character block dta d'#39' '#39);
 writeln('-bc$xxxx'#9'block code at address $xxxx');
 writeln('-bd$xxxx'#9'block data at address $xxxx');
 writeln('-bac$xxxx'#9'block with address of new code blocks');
 writeln('-bad$xxxx'#9'block with address of new data blocks');

 halt;
end;


procedure Parametr(p: string);
var j: char;
begin
 j:=UpCase(p[2]);

 if not(p[1] in ['/','-']) then Info;

 case j of
  'D': Data:=1;
  'L': Zamiana:=1;
  'A': Val(copy(p,3,length(p)-2),org,Code);
  'S': case UpCase(p[3]) of
        'D': store_type:='D';
        'A': store_type:='A';
//        'I': store_type:='I';
       else
        Val(copy(p,3,length(p)),skp,Code);  // -S$xxxx
       end;

  'M': Mnemo:=1;
  'B': case UpCase(p[3]) of

        'A': case UpCase(p[4]) of

              'C': begin
                    Val(copy(p,5,length(p)-2),cpu,Code);

                    tst[cpu].beg:=true;
                    tst[cpu].typ:=true;

                    tst[cpu].siz:='B';
                   end;

              'D': begin
                    Val(copy(p,5,length(p)-2),cpu,Code);

                    tst[cpu].beg:=true;
                    tst[cpu].typ:=false;

                    tst[cpu].siz:='W';
                   end;
             else
              Info;
             end;

        'C': begin
              Val(copy(p,4,length(p)-2),cpu,Code);

             { for i:=cpu to $FFFF-1 do
               if tst[i].beg then
                Break
               else
                tst[i].typ:=true;   }

              tst[cpu].typ:=true;
              tst[cpu].beg:=true;

              ram[cpu div 8]:=ram[cpu div 8] or tand[cpu mod 8];
              use[cpu div 8]:=use[cpu div 8] or tand[cpu mod 8];


             end;

        'D': begin
              Val(copy(p,4,length(p)-2),cpu,Code);

              {for i:=cpu to $FFFF-1 do
               if tst[i].beg then
                Break
               else
                tst[i].typ:=false;    }

              tst[cpu].typ:=false;
              tst[cpu].beg:=true;

              ram[cpu div 8]:=ram[cpu div 8] or tand[cpu mod 8];
              use[cpu div 8]:=use[cpu div 8] or tand[cpu mod 8];

             end;
       else
        Info;
       end;
 else
  Info;
 end;

end;


procedure Otworz(var p: string);
begin
 assignFile(h,p); reset(h);

 seek(h, skp);
end;


procedure testuj(var tmp: string);
var mne, adr, txt: string;
    i, j: integer;
begin

 if tmp<>'' then begin
  mne:=UpCase(tmp[1])+UpCase(tmp[2])+UpCase(tmp[3])+UpCase(tmp[4])+UpCase(tmp[5]);

  adr:=copy(tmp,4,length(tmp));

{
  if (mne='JSR $') or (mne='JMP $') or (mne='BPL $') or (mne='BMI $') or (mne='SBC $') or (mne='ADC $')
  or (mne='BNE $') or (mne='BCS $') or (mne='BCC $') or (mne='BVC $') or (mne='BVS $') or (mne='BEQ $')
  or (mne='STA $') or (mne='STX $') or (mne='STY $') or (mne='CMP $') or (mne='CPY $') or (mne='CPX $')
  or (mne='ORA $') or (mne='AND $') or (mne='ASL $') or (mne='ROR $') or (mne='LSR $') or (mne='ROR $')
  or (mne='EOR $') or (mne='INC $') or (mne='DEC $')
}

  if (mne='JSR $') or (mne='JMP $') or (mne='BPL $') or (mne='BMI $')
  or (mne='BNE $') or (mne='BCS $') or (mne='BCC $') or (mne='BVC $') or (mne='BVS $') or (mne='BEQ $')
  then begin

   if pos(',',adr)>0 then begin
    txt:='';
    i:=1;
    while adr[i]<>',' do begin txt:=txt+adr[i]; inc(i) end;
    adr:=txt;
   end;

   i:=StrToInt(adr);

   tst[i].beg:=true;

   for j:=i+1 to $FFFF-1 do
    if tst[i].beg then
     Break
    else
     tst[i].typ:=true;

  // sprawdzamy czy jest potrzebny dodatkowy przebieg
   if ((use[i div 8] and tand[i mod 8])=0) and (cpu>i) and not(tst[i].typ) then loop:=true;

  end;

 end;

end;



procedure saveDTA;
var siz: char;
    typ: Boolean;
    a, b: byte;
    i, max_licz: integer;
begin

if AccessFile(plik+'.asm') then begin
 assignFile(ou,plik+'.asm'); rewrite(ou);
end else begin
 writeln;
 writeln('ERROR: File ',plik+'.asm',' in use.');
 halt;
end;


 cpu:=org; licz:=0;

 tst[cpu].beg:=true;

 siz:='B';
 typ:=true;


 while not eof(h) do begin

  if tst[cpu].beg then begin
   siz:=tst[cpu].siz;
   typ:=tst[cpu].typ;
  end;

  if siz='W' then begin
   read(h,a); read(h,b);
   i:=a+b shl 8;

   tst[i].beg:=true;
   tst[i].typ:=typ;
   tst[i].siz:='B';

   tst[i+$fc6].beg:=true;
   tst[i+$fc6].typ:=typ;
   tst[i+$fc6].siz:='B';

   inc(cpu,2);
  end else begin
  
   read(h,b);
   inc(cpu);
  end;

 end;

 seek(h, skp);


(******************************************************************************)

 cpu:=org; licz:=0;

 siz:='B';
 typ:=true;

 SaveAsm(#9+'opt h-'); SaveOrg(cpu); SaveAsm('');

 while not eof(h) do begin

  if tst[cpu].beg then begin
   siz:=tst[cpu].siz;
   typ:=tst[cpu].typ;
  end;


  read(h,byt); _old:='';

  if siz='W' then begin
   i:=byt; read(h, byt); i:=i+integer(byt shl 8);
   max_licz:=5;
  end else begin
   i:=byt;
   max_licz:=15;
  end;

  if {((cpu-org) mod 256=0) or} (tst[cpu].beg) then begin

   writeln(ou); if licz<>0 then writeln(ou);

   if tst[cpu].beg then _old:=ety+IntToHex(cpu,4);

   licz:=0;
  end;



  if siz='W' then begin

   if licz=0 then begin
    write(ou,_old+#9+'dta a('+Ety+IntToHex(i,2)+')');
   end else
    write(ou,',a('+Ety+IntToHex(i,2)+')');

   inc(cpu, 2);
  end else begin

   if licz=0 then begin
    write(ou,_old+#9+'dta $'+IntToHex(i,2));
   end else
    write(ou,',$'+IntToHex(i,2));

   inc(cpu);
  end;

  inc(licz);
  if licz>max_licz then begin writeln(ou); licz:=0; end;
 end;

 closeFile(ou); closeFile(h);

end;




begin
writeln;
writeln('CPU6502 DisAsembler v2.2 by Tebe/Madteam');

org:=$400; Data:=0; Zamiana:=0; Skp:=0; Mnemo:=0;

for i:=0 to $FFFF-1 do begin
 tst[i].typ:=true;
 tst[i].beg:=false;
end;

if paramcount<1 then Info;

plik:=paramstr(1);

if not(TestFile(plik)) then begin
 writeln('ERROR: File ',plik,' not exists !');
 halt;
end;

for i:=2 to paramcount do Parametr(paramstr(i));


if not(TestFile(plik)) then begin
 writeln('ERROR: File ',plik,' not exists !');
 halt;
end;

{ *- wczytanie pliku MNEMO.D65 z mnemonikami CPU6502 -* }
writeln('Read file: MNEMO.D65');

if not(TestFile('mnemo.d65')) then begin
 writeln('ERROR: File ''MNEMO.D65'' not found.');
 halt;
end;

for i:=0 to 255 do tab[i]:=''; name:=plik;
assignFile(f,'mnemo.d65'); reset(f);
while not eof(f) do begin
 readln(f,a);
 if (pos('$',a)>0) and (pos(';',a)=0) then begin
  b:=getString(','); val(b,bajt,Code); i:=bajt;
  b:=getString(chr(39)); b:=getString(chr(39)); tab[i]:=b;
 end;
end; closeFile(f);


{ *- wczytanie pliku MEMORY.D65 z opisami komorek pamieci -* }
if Zamiana=1 then begin
writeln('Read file: MEMORY.D65');

if not(TestFile('memory.d65')) then begin
 writeln('ERROR: File ''MEMORY.D65'' not found.');
 halt;
end;


fillchar(ram2,sizeof(ram2),0);

assignFile(g,'_temp.$$$'); rewrite(g);
assignFile(f,'memory.d65'); reset(f);
while not eof(f) do begin
 readln(f,tmp);

 a:='';

 i:=1;
 
 if tmp<>'' then
  while (tmp[i]<>';') and (i<=length(tmp)) do begin a:=a+tmp[i]; inc(i) end;

 if (pos('$',a)>0) and (pos(';',a)=0) then begin
  b:=GetString('$'); while (b<>'') and (b[length(b)]=' ') do delete(b,length(b),1);
  writeln(g,b+' $'+a); b:='$'+copy(a,1,4); val(b,_adr,Code);
  k:=_adr div 8; ram2[k]:=(ram2[k] or tand[_adr mod 8]);
 end;

end; closeFile(f); closeFile(g);
end;


{ *- Deasemblacja -* }
write(plik+' -> '); Otworz(plik); dlug:=filesize(h);
if pos('.',plik)>0 then plik:=copy(plik,1,pos('.',plik)-1);
writeln(plik+'.asm  Address: $',IntToHex(org,4));


{ *- jesli DATA=1 wtedy tylko dta b(.......) -* }
if data=1 then begin
pass:=2;

saveDTA;

writeln('Done.');
halt;

end;


write('Pass ');

loop:=true;

while loop do begin

seek(h, skp);

{ *- PASS 1 -* }
pass:=1; cpu:=org; store:=0;

tst[cpu].beg:=true;

loop:=false;

while not eof(h) do begin
 read(h,byt);

 tmp:='';

 if (tab[byt]<>'') then begin
  out:=Etykieta;

  tmp:=Decode(byt);

  ok:=true;
  typ:=tst[cpu].typ;
  for i:=0 to len-1 do
   if (tst[cpu+i].typ<>typ) or ((i>0) and (tst[cpu+i].beg)) then begin ok:=false; Break end;

  if not(tst[cpu].beg) and not(tst[cpu-1].typ) then ok:=false;


  if ok then begin    // OK = TRUE

   testuj(tmp);
   out:=out+tmp;

   for i:=0 to len-1 do tst[cpu+i].typ:=true;


   if pos(' $',tmp)>0 then begin

    tmp:=copy(tmp,pos(' $',tmp),length(tmp));

    if pos(',',tmp)>0 then begin
     txt:='';
     i:=1;
     while tmp[i]<>',' do begin txt:=txt+tmp[i]; inc(i) end;
     tmp:=txt;
    end;

    i:=StrToInt(tmp);
    use[i div 8]:=use[i div 8] or tand[i mod 8];

   end;


  end else begin      // OF = FALSE


   if pos(' $',tmp)>0 then begin

    tmp:=copy(tmp,pos(' $',tmp),length(tmp));

    if pos(',',tmp)>0 then begin
     txt:='';
     i:=1;
     while tmp[i]<>',' do begin txt:=txt+tmp[i]; inc(i) end;
     tmp:=txt;
    end;

    i:=StrToInt(tmp);
    if (use[i div 8] and tand[i mod 8])=0 then
     ram[i div 8]:=ram[i div 8] and (tand[i mod 8] xor $ff);

    i:=cpu;
    ram[i div 8]:=ram[i div 8] and (tand[i mod 8] xor $ff);
   end;

   out:=Etykieta+'dta $'+IntToHex(byt,2);
                     //writeln('- ',out);

   if FilePos(h)+len>=FileSize(h) then goto stop0;

   seek(h, FilePos(h)-(len-1));     // (len-1) : len=BYTE !!! koniecznie

   tst[cpu].typ:=false;

   len:=1;
  end;

  inc(cpu,len);

 end else begin
  out:=Etykieta+'dta $'+IntToHex(byt,2);

                    //writeln('> ',out);
  for i:=cpu to $FFFF-1 do
   if tst[i].beg then
    Break
   else
    tst[i].typ:=false;

  inc(cpu);
 end;

end;

stop0:

write('.');

end;


closeFile(h);



{ *- PASS 2 -* }
Otworz(name);

assignFile(t,'_tmp.$$$'); rewrite(t);
assignFile(ou,plik+'.$$$'); rewrite(ou);

pass:=2; cpu:=org; store:=0; lin:=0;

SaveAsm(#9+'opt h-'); SaveAsm('');
SaveOrg(org); //SaveAsm('');

_old:=''; Licz:=0; _byt:=0;

while not eof(h) do begin
 read(h,byt);

 status:=tst[cpu].typ;

 if (tab[byt]<>'') and status then begin
  adr2:='';
  out:=Etykieta+Decode(byt);

  if adr2<>'' then begin
   if (Etykieta<>adr2+Spa) then out:=adr2+out;
   SaveAsmTst(out);
  end else
   SaveAsmTst(out);

  inc(cpu,len);
 end else begin

  if store=0 then begin

   case na_znaki(byt) of
    'D': begin
          out:=Etykieta+'dta $'+IntToHex(byt,2);

          if store_type in ['A','I'] then begin
           out:=out+#13#10;
           store:=255;
          end;

         end;

    'A': begin
          out:=Etykieta+'dta c'#39+chr(byt);
         end;

    'I': begin
          out:=Etykieta+'dta d'#39+chr(ata2int(byt));
         end;
   end;

  end else
   if Etykieta=Spa then begin

    case na_znaki(byt) of
     'D': begin

           if store_type in ['A','I'] then
            out:=#39
           else
            out:='';

           out:=out+',$'+IntToHex(byt,2);

           if store_type in ['A','I'] then begin out:=out+#13#10; store:=255 end;

          end;

     'A': begin

           case store_type of
            'D': SaveAsm('');
            'I': SaveAsm(#39);
           end;

           out:=chr(byt);
          end;

     'I': begin

           case store_type of
            'D': SaveAsm('');
            'A': SaveAsm(#39);
           end;

           out:=chr(ata2int(byt));
          end;

    end;

   end else begin

    case store_type of
         'D': SaveAsm('');
     'A','I': SaveAsm(#39);
    end;

    case na_znaki(byt) of
     'D': begin
           out:=Etykieta+'dta $'+IntToHex(byt,2);

           if store_type in ['A','I'] then begin
            out:=out+'';
            store:=200;
           end;

          end;

    'A': begin
           case store_type of
            'D': SaveAsm('');
            'I': SaveAsm(#39);
           end;

          out:=Etykieta+'dta c'#39+chr(byt);
         end;

    'I': begin
           case store_type of
            'D': SaveAsm('');
            'A': SaveAsm(#39);
           end;

          out:=Etykieta+'dta d'#39+chr(ata2int(byt));
         end;
    end;

    store:=0;
   end;

  inc(cpu); SaveAsmTst('?'); write(ou,out); inc(store);

//  if store>15 then begin

   case store_type of
        'D': if store>15 then begin SaveAsm(''); store:=0 end;
    'A','I': if store>31 then begin SaveAsm(#39); store:=0 end;
   end;

//   store:=0;
//  end;

 end;

end;


if store>0 then begin

 case store_type of
      'D': SaveAsm('');
  'A','I': SaveAsm(#39);
 end;

 store:=0;
end;

SaveAsmTst('?'); SaveAsmTst('?');
closeFile(h); closeFile(ou); closeFile(t);

write('.');


{ *- PASS 3 -* }
assignFile(f,plik+'.$$$'); reset(f);


if AccessFile(plik+'.asm') then begin
 assignFile(ou,plik+'.asm'); rewrite(ou); dlug:=lin;
end else begin
 writeln;
 writeln('ERROR: File ',plik+'.asm',' in use.');
 halt;
end;

cpu:=0; org:=0; pass:=3;


if Zamiana=1 then begin
assignFile(g,'memory.d65'); reset(g); byt:=0;

while not eof(g) do begin
 readln(g,tmp);

 a:='';

 i:=1;
 
 if tmp<>'' then
  while (tmp[i]<>';') and (i<=length(tmp)) do begin a:=a+tmp[i]; inc(i) end;

 if (pos('$',a)>0) and (pos(';',a)=0) and (pos('+',a)=0) then begin
  b:=GetString('$'); while b[length(b)]=' ' do delete(b,length(b),1);
  i:=length(b); if i>byt then byt:=i;
 end;
end; closeFile(g);


assignFile(g,'memory.d65'); reset(g);
while not eof(g) do begin
 readln(g,tmp);

 a:='';

 i:=1;

 if tmp<>'' then begin
  while tmp[i] in [' ',#9] do inc(i);

  if tmp[i]<>';' then a:=tmp;
 end;

 if (pos('$',a)>0) {and (pos(';',a)=0) }and (pos('+',a)=0) then begin
  b:=GetString('$'); while b[length(b)]=' ' do delete(b,length(b),1);
  out:=''; while length(out+b)<byt do out:=out+' '; _old:=b+out;
  insert('= $'+a,_old,byt+1); writeln(ou,_old);
 end;
end;

 writeln(ou);
 closeFile(g);
end;


while not eof(f) do begin
a:=''; hlp:=0;
  while (a<>'$$$') and (hlp<128) do begin
   readln(f,a); if hlp>127 then begin writeln('ERROR: ',hlp); halt; end;
   wor[hlp]:=a; inc(hlp);
  end;

  assignFile(g,'_tmp.$$$'); reset(g);

  while not eof(g) do begin
  readln(g,b); i:=length(Ety)+4; a:=copy(b,1,i); b:=copy(b,i+1,length(b)-i);
   for pom:=0 to hlp-1 do begin
   adr:=copy(wor[pom],2,length(wor[pom]));

    if pos(a,adr)>0 then begin
     i:=pos(a,wor[pom]); delete(wor[pom],i,length(a)); insert(b,wor[pom],i);
    end;
   end;
  end; closeFile(g);


  for pom:=0 to hlp-1 do
  {if wor[pom]<>'' then} begin
   writeln(ou, wor[pom]);

  // wstawiamy pusty wiersz po JMP, JSR, RTS
   if (pos('jmp',wor[pom])>0) or (pos('rts',wor[pom])>0) or (pos('jsr',wor[pom])>0) then writeln(ou);

   inc(cpu, hlp);
  end;

end; closeFile(f); closeFile(ou);

writeln('.');


if Zamiana=1 then begin assignFile(g,'_temp.$$$'); reset(g); closeFile(g); erase(g); end;
assignFile(g,'_tmp.$$$'); reset(g); closeFile(g); erase(g);
assignFile(g,plik+'.$$$'); reset(g); closeFile(g); erase(g);

writeln('Done.');
end.

